diff -urN publicfile-0.52.orig/Makefile publicfile-0.52/Makefile
--- publicfile-0.52.orig/Makefile	Tue Nov  9 16:23:46 1999
+++ publicfile-0.52/Makefile	Fri Feb  9 19:02:44 2001
@@ -235,17 +235,17 @@
 	./compile hier.c
 
 httpd: \
-load httpd.o main.o pathdecode.o file.o filetype.o httpdate.o \
+load httpd.o main.o pathdecode.o pathquery.o file.o filetype.o httpdate.o \
 percent.o prot.o timeoutread.o timeoutwrite.o libtai.a case.a getln.a \
 stralloc.a alloc.a substdio.a error.a open.a sig.a env.a str.a fs.a \
 socket.lib
-	./load httpd main.o pathdecode.o file.o filetype.o \
+	./load httpd main.o pathdecode.o pathquery.o file.o filetype.o \
 	httpdate.o percent.o prot.o timeoutread.o timeoutwrite.o \
 	libtai.a case.a getln.a stralloc.a alloc.a substdio.a \
 	error.a open.a sig.a env.a str.a fs.a  `cat socket.lib`
 
 httpd.o: \
-compile httpd.c pathdecode.h stralloc.h gen_alloc.h file.h tai.h \
+compile httpd.c pathdecode.h pathquery.h stralloc.h gen_alloc.h file.h tai.h \
 uint64.h filetype.h stralloc.h percent.h stralloc.h stralloc.h sig.h \
 exit.h fmt.h case.h str.h tai.h httpdate.h stralloc.h tai.h \
 timeoutread.h timeoutwrite.h substdio.h error.h getln.h
@@ -361,6 +361,10 @@
 pathdecode.o: \
 compile pathdecode.c pathdecode.h stralloc.h gen_alloc.h
 	./compile pathdecode.c
+
+pathquery.o: \
+compile pathquery.c pathquery.h stralloc.h gen_alloc.h
+	./compile pathquery.c
 
 percent.o: \
 compile percent.c percent.h stralloc.h gen_alloc.h
diff -urN publicfile-0.52.orig/httpd.c publicfile-0.52/httpd.c
--- publicfile-0.52.orig/httpd.c	Tue Nov  9 16:23:46 1999
+++ publicfile-0.52/httpd.c	Fri Feb  9 19:02:50 2001
@@ -15,6 +15,7 @@
 #include "substdio.h"
 #include "error.h"
 #include "getln.h"
+#include "pathquery.h"
 
 int safewrite(int fd,char *buf,int len)
 {
@@ -274,6 +275,7 @@
     else
       if (!stralloc_copy(&path,&url)) _exit(21);
 
+    pathquery(&path);
     if (!path.len || (path.s[path.len - 1] == '/'))
       if (!stralloc_cats(&path,"index.html")) _exit(21);
 
diff -urN publicfile-0.52.orig/pathquery.c publicfile-0.52/pathquery.c
--- publicfile-0.52.orig/pathquery.c	Thu Jan  1 09:00:00 1970
+++ publicfile-0.52/pathquery.c	Fri Feb  9 19:02:58 2001
@@ -0,0 +1,17 @@
+#include "pathquery.h"
+
+void pathquery(stralloc *fn)
+{
+  int i;
+  int j;
+  char ch;
+
+  j = 0;
+  for (i = 0;i < fn->len;++i) {
+    ch = fn->s[i];
+    if (ch == 0) break;
+    if (ch == '?') break;
+    fn->s[j++] = ch;
+  }
+  fn->len = j;
+}
diff -urN publicfile-0.52.orig/pathquery.h publicfile-0.52/pathquery.h
--- publicfile-0.52.orig/pathquery.h	Thu Jan  1 09:00:00 1970
+++ publicfile-0.52/pathquery.h	Fri Feb  9 19:02:58 2001
@@ -0,0 +1,8 @@
+#ifndef PATHQUERY_H
+#define PATHQUERY_H
+
+#include "stralloc.h"
+
+extern void pathquery(stralloc *);
+
+#endif
